#!/usr/bin/env python
"""ApacheΥȤˡ饤Ȥں߻֤׻

ϡκǸ夢ˤ롢ں߻֤狼ʤ饤Ȥ
ڼΤƤƷ׻Ƥ롣
"""

from __future__ import generators
from time import strptime, strftime

LOGFILE = 'access_log_masked'

# 󤷤Ƥ
STILLTIME = 60 * 5

def parse_access_time(line):
    "򥷥ƥλˤ֤"

    tokens = line.split()
    return long(strftime(
        '%s', strptime(tokens[3][1:], '%d/%b/%Y:%H:%M:%S'))), tokens[0]

#
# Ĥ(3ĤȤۤƱ)
#
def make_accessdata1(fp):
    "ŤǥΥꥹȤ"

    items = []
    for line in fp.readlines():
        items.append(parse_access_time(line))
    return items

def make_accessdata2(fp):
    "ߤΥǥΥꥹȤ"

    return [parse_access_time(line) for line in fp.readlines()]

def make_accessdata3(fp):
    "ͥ졼Ѥ"

    for line in fp.readlines():
        yield parse_access_time(line)

# ºݤ˻Ȥؿmake_accessdata()ǸƤ֤褦ˤˤ
make_accessdata = make_accessdata1

def analyze(fp, cli=None):
    "ϥ롼"

    visits = 0
    ctable = {}
    exist_times = []
    uniq_clients = []
    accessdata = make_accessdata(fp)
    accessdata.sort() # 1,2Τߡ3ϥͥ졼֥ȤʤΤsortǤʤ
    visits_cli = [] # Υ饤ȤΤ

    for accesstime, client in accessdata:
        # ˡ饤ȿη׻
        if not uniq_clients.count(client):
            uniq_clients.append(client)

        # ФƤä饤Ȥõơں߻֤׻
        for exit_client in ctable.keys():
            lastaccess, firstaccess = ctable[exit_client]
            if STILLTIME < accesstime - lastaccess:
                exist_times.append(lastaccess - firstaccess)
                visits += 1
                del ctable[exit_client]

                if cli:
                    if cli != exit_client: continue
                    visits_cli.append(lastaccess - firstaccess)
                # 饤Ȥں߻֤ɽ
                print '%s:\t%d sec' % (exit_client, lastaccess - firstaccess)

        # 饤ȤΥɥ쥹ơ֥˥ɲ
        cur = ctable.get(client)
        if cur:
            lastaccess, firstaccess = cur
            ctable[client] = accesstime, firstaccess
        else:
            ctable[client] = accesstime, accesstime

    # ں߻֤η׻
    total = reduce(lambda a,b: a+b, exist_times)

    print '-' * 60
    if cli:
        clitotal = reduce(lambda a,b: a+b, visits_cli)
        clilen = len(visits_cli)
        print cli, 'visits:', clilen
        print cli, 'length of stay:', clitotal
        print cli, 'average:', float(clitotal) / clilen
        print '-' * 60

    # ˡ饤ȿ
    print 'Unique clients:', len(uniq_clients)
    # ˬ(ں楯饤ȴޤ)
    print 'Total visits:', visits + len(ctable.keys())
    # ں߻
    print 'Total length of stay(sec):', total
    # Τʿ
    print 'Total average(sec):', float(total) / len(exist_times)
        
if __name__ == '__main__':
    import sys
    client = None
    if len(sys.argv) == 3: client = sys.argv[2]
    analyze(open(sys.argv[1]), client)            
