#!/usr/bin/env python
"""Slashdot JapanRSSϤ⥸塼

Ȥˤ륪ꥸʥRSS䤽ȤˤRSS3ΤΤϤ롣
"""

from xml.sax.handler import ContentHandler
from xml.sax import make_parser
from cgi import escape
from StringIO import StringIO

class RSSHandler(ContentHandler):
    "RSSѡϥɥ"

    # ǡΥ֥åȤǧ̾
    BLOCK_ELEMENTS = ('channel', 'item')

    # ֥åΥǡȤǧ̾
    ACCEPT_ELEMENTS = (
        'title', 'link', 'description', 'language', 'rights', 'created',
        'publisher', 'creator', 'subject', 'updatePeriod', 'updateFrequency',
        'updateBase')

    # 󥳡ɻΥǥå̾
    ENCODING = 'euc-jp'
                              
    def __init__(self):
        self.blocks = []    # ֥åΥꥹ
        self.block = {}     # Υ֥åΥǡϤХåե
        self.nowtext = None # ߤΥƥȥΡɾ
        self.in_block = 0   # ֥å⤫ɤΥե饰
        self.buf = StringIO()

    def characters(self, text):
        "ʸǡиȤΥϥɥ"
        
        if self.in_block:
            self.buf.write(escape(text.encode(self.ENCODING)).strip())

    def startElement(self, name, attrs):
        "ϥиȤΥϥɥ"

        if name in self.BLOCK_ELEMENTS:
            self.in_block = 1
            
    def endElement(self, name):
        "λиȤΥϥɥ"

        if self.in_block:
            name = name.encode(self.ENCODING).split(':', 1)[-1]
            if name in self.ACCEPT_ELEMENTS:
                self.block[name] = self.buf.getvalue()
                self.buf = StringIO()
        if name in self.BLOCK_ELEMENTS:        
            self.in_block = 0
            if self.block:
                self.blocks.append(self.block)
                self.block = {}

    def getblocks(self):
        "ѤΥ֥åΥꥹȤ֤"

        return self.blocks

def parse_rss(fp):
    parser = make_parser()
    handler = RSSHandler()
    parser.setContentHandler(handler)
    parser.parse(fp) 
    return handler.getblocks()

# RSS3Υѡ

class RSS3Parser:
    def parse_block(self, block):
        "֥å򼭽񥪥֥ȤΥꥹȤˤ"

        dic = {}
        for key, val in [line.split(':', 1) for line in block.split('\n')]:
            dic[key] = val.strip()
        return dic

    def parse(self, fp):
        "ե륪֥ȤɤߤǼΥꥹȤ˲ù"
        
        # ɽ
        # blocks = []
        # for block in open(RSSFILE).read().split('\n\n'):
        #     block = block.strip()
        #     if block: blocks.append(parse_block(block))

        # ꥹɽ
        return [self.parse_block(block)
                for block in fp.read().split('\n\n') if block.strip()]

def parse_rss3(fp):
    return RSS3Parser().parse(fp)

if __name__ == '__main__':
    # ͥåȥۤRDFˤopenؿΤȤ򲼤ΤΤˤ
    #
    # from urllib import urlopen
    # parse_rss(urlopen('http://slashdot.jp/slashdot.rdf').read())

    print parse_rss(open('slashdot.rdf'))       
    print parse_rss3(open('rss2txt_slashdotjp.rdf'))       
